%this is the continuation value

function w = w(b,z)
global sigma gamma z_H z_L A u up v vp w_b

%think about the initial guess

if sigma == gamma
    c = (b + (b.^2 + 4*z^((gamma+1)/gamma)).^.5)/2;
else
    c0 = b+z;  %pretty bad guess, plus it is used all over again, could/should be improved
    %c0 = b + .9*z^((1+gamma)/(gamma+sigma)); %this is true for b = 0
    %c0 = (b + (b^2 + 4*z^((gamma+1)/gamma))^.5)/2;
    options = optimset('display', 'off', 'tolfun', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000); 
    c=fsolve(@(c) up(c) - vp((c-b)/z)/z, c0, options);
end
w = u(c) - v((c-b)/z);