function IC = IC(x)
global N Z1 A u up v vp T W W_b eta zP R beta P Z2 phi

 c1       = x(1:N^2);
 y1       = x(N^2+1:2*N^2);
 b1       = x(2*N^2+1:3*N^2);

    zvec = (kron(Z1,ones(N,1)));
    
    conttrue = W(b1, T);
    Wtrue = conttrue(1:N^2);
    %Wtrueprime = cont1(N^2+1: 2*N^2);
    
    %truthtelling
    %reshape(kron(ones(N,1),P).*(u(c1)- phi*v(y1./zvec) + beta*Wtrue),N,N)
    LHS = (kron(ones(N,1),sum(reshape(kron(ones(N,1),P).*(u(c1)- phi*v(y1./zvec) + beta*Wtrue),N,N))))';
        
    %[lhs1, lhs1, ..., lhs1; 
    % lhs2, lhs2, ..., lhs2;
    % ...; 
    % lhsN, lhsN, ..., lhsN]
    
    RHS = zeros(N,N);
    
    %a loop for reports
    for m = 1:N
     
    %reports m, true type in each N lines
        
        c = reshape(c1(N*(m-1)+1:N*m)*ones(1,N),N^2,1);
        y = reshape(y1(N*(m-1)+1:N*m)*ones(1,N),N^2,1);
        b = reshape(b1(N*(m-1)+1:N*m)*ones(1,N),N^2,1);
        
        %their expected utility in m-th line since report m
        
        %RHS(m,:) = P'*reshape((u(c) - phi*v(y./zvec) + beta*W(b, T)), N, N);
        contlie = W(b, T);
        Wlie = contlie(1:N^2);
        %kron(ones(N,1),P).*(u(c)- phi*v(y./zvec) + beta*Wlie);
        RHS(:,m) = (sum(reshape(kron(ones(N,1),P).*(u(c)- phi*v(y./zvec) + beta*Wlie),N,N)))';
    end
        RHS;
        IC = LHS - RHS;
        
       
        %min(min(IC))
        if min(min(IC))< -10^(-5) %if we want this more exact, need to make the fsolve more exact
            display 'some IC is fucked up at this solution'
            %break
        end  
        
    %save('IC', 'IC')

