function calib4 = calib4(x)

global Z1 A u up v vp W W_b N T TG TL mu_yP eta ZP zP Z1mat Z2mat grid_A R beta Z2 P PP phi N2 NA N policies data Pemp y_21 y_22 mures l phi1 phi2 %S1 S2 alpha
x;
phi = x(1);
eta = x(2);
beta = x(3);
phi2 = x(4);
phi1 = beta;

%W   = @(b, t) sum([kron(t, ones(N,1));kron(t, ones(N,1))].*wdyn(b),2);
 
k = 1;
%x0 =.2*ones(3*N^2+N*(N+1)/2+N-1 + N*(N+1), 1); %for allocations, lambdas, mu's, parent's allocations    
display 'make sure to change the definition of the continuation value in the file systemnew.m'    
for j = 1:N
        P = TG(j,:)'; %column vector of probabilities for kids' types
        zP = ZP(j);
        
        Z1 = Z1mat(j,:)';
        Z2 = Z2mat(j,:)';
        
    for i = 1: NA
        %tic;
        A = grid_A(i);
        %x0 = .1*ones(3*N^2+N*(N+1)/2+N-1 + N*(N+1), 1); %for allocations, lambdas, mu's, parent's allocations
        
        %if k < 3
        x0 = policies(:, k);
        %end
        
        %check whether child's savings are taken as given by parents
        %y1 = reshape(x0(N^2+1:2*N^2), N, N);
        %y2 = y1';
        %y1 = reshape(y1, N^2, 1);
        %y2 = reshape(y2, N^2, 1);
        %S1 = exp(- 4.6971 + 1.1489*log(y1*exp(mu_yP)));
        %S2 = exp(- 4.6971 + 1.1489*log(y2*exp(mu_yP)));
        
        
        %options = optimset('display', 'iter', 'tolfun', 10^(-5), 'tolX', 10^(-5), 'maxfunevals', 1000000, 'maxiter', 1000000,'largescale', 'on');
        %options = optimset('display', 'iter','tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'NonlEqnAlgorithm', 'gn'); 
        options = optimset('display', 'off','tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000,'maxiter', 1000000);%
        x = fsolve(@systemnew, x0, options);
        %sum(sum(abs(systemnew(x))))
    
        %if sum(sum(abs(systemnew(x))))>10^-3
        %   display 'we did not solve the system'
        %end
        policies(:, k) = x; 
       
        %generate some output :-)
        %need to generate the extra states (i.e. have only (1,2), need also (2,1))
        cP = x(3*N^2+N*(N+1)/2+N-1 + 1: 3*N^2+N*(N+1)/2+N-1 + N*(N+1)/2);
        yP = x(3*N^2+N*(N+1)/2+N-1 + N*(N+1)/2 + 1: 3*N^2+N*(N+1)/2+N-1 + N*(N+1));
        lambda = x(3*N^2+1: 3*N^2+N*(N+1)/2);
        cPres = zeros(N,N);
        yPres = zeros(N,N);
        lres = zeros(N,N);
        mures((k-1)*(N-1)+1:k*(N-1)) = x(3*N^2+N*(N+1)/2+1:3*N^2+N*(N+1)/2+N-1);
        
        for n = 1:N
            cPres(n, 1:n) = cP(n*(n-1)/2+1:n*(n+1)/2)';
            cPres(1:n, n) = cP(n*(n-1)/2+1:n*(n+1)/2);
            yPres(n, 1:n) = yP(n*(n-1)/2+1:n*(n+1)/2)';
            yPres(1:n, n) = yP(n*(n-1)/2+1:n*(n+1)/2);
            lres(n, 1:n) = lambda(n*(n-1)/2+1:n*(n+1)/2)';
            lres(1:n, n) = lambda(n*(n-1)/2+1:n*(n+1)/2);
        end
    
        cPres = reshape(cPres, N^2, 1);
        yPres = reshape(yPres, N^2, 1);
        lres = reshape(lres, N^2, 1);
        W   = @(b, t) sum([kron(t, ones(N,1));kron(t, ones(N,1))].*wdyn(b),2);
        b1 = x(2*N^2+1:3*N^2);
        walue1 = W(b1, T);
        walue1 = walue1(1:N^2);

        %RECOVER AND TRANSFORM INTO MATRICES
        c1       = reshape(x(1:N^2), N, N); 
        y1       = reshape(x(N^2+1:2*N^2), N, N);
        b1       = reshape(x(2*N^2+1:3*N^2), N, N);
        walue1   = reshape(walue1, N, N);
        
        %define c2 by symmetry
        c2 = c1';
        y2 = y1';
        b2 = b1';
        walue2 = walue1';
        
        beqmat((k-1)*N+1:k*N,:) = b1'; %bequest matrix to compare to Kevin's?
        
        %convert back into vectors
        c1 = x(1:N^2);
        y1 = x(N^2+1:2*N^2);
        b1 = x(2*N^2+1:3*N^2);
        walue1 = reshape(walue1, N^2, 1);
        
        c2 = reshape(c2, N^2, 1);
        y2 = reshape(y2, N^2, 1);
        b2 = reshape(b2, N^2, 1);
        walue2 = reshape(walue2, N^2, 1);
        
        g1 = c1 - y1;
        g2 = c2 - y2;
    
        %walue1 = W(b1, T);
        %walue2 = W(b2, T);
        %walue1 = walue1(1:N^2);
        %walue2 = walue2(1:N^2);

        walue = u(cPres) - phi*v(yPres/zP) + eta*(u(c1) - phi*v(y1./kron(Z1, ones(N,1))) + beta*walue1+...
            + u(c2) - phi*v(y2./kron(ones(N,1), Z1)) + beta*walue2);
        V(k, :) = [sum(walue)/N^2,sum(lres)]; %careful here, need uniform on Z1
      
        %the probability of a given entry
        totP = PP(j,i)*ones(N^2,1).*kron(P, ones(N,1)).*kron(ones(N,1), P);
       
        Z11vector((k-1)*N^2+1:k*N^2) = [kron(Z1,ones(N,1))];%vector of first kid's types
        data((k-1)*N^2+1:k*N^2, :) = [A*ones(N^2,1), zP*ones(N^2,1), totP, c1, c2, cPres, y1, y2, yPres, g1, g2, b1, b2, walue1, walue2, walue, lres];
        
        %check the IC's in a separate function
        %min(min(IC(x)))
        
        %IC(x);
    
        %second period's allocations
        output21 = output2dyn(b1);
        %output22 = output2dyn(b2);
        y_21((k-1)*N2^2+1:k*N2^2, :) = output21(1:N^2,:);
        bprime((k-1)*N2^2+1:k*N2^2, :) = output21(2*N^2+1:3*N^2,:);
        %y_22((k-1)*N2^2+1:k*N2^2, :) = output22(1:N^2,:);
        
        %c_21((k-1)*N2^2+1:k*N2^2, :) = output21(1+N^2:2*N^2,:);
        %c_22((k-1)*N2^2+1:k*N2^2, :) = output22(1+N^2:2*N^2,:);

        %save('policies','policies') %to have always the new numbers in
        %save('policies1_2_2_b>0','policies')
        k = k+1;
        
        %initial guess for next asset value and the same parents' productivity
        x0 = x;
        %toc;
    end
    x0 = policies(:, 1+(j-1)*NA); %use the guess from the same asset level when going to next productivity level
    
end

%save ('Policies2015/policies1_1.mat', 'policies')
%end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%     LABOR    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%define the probability
Pemp = data(:,3);
%labor of kid 1
l1 = data(:,7)./Z11vector';
%labor of parent
lP = data(:,9)./data(:,2);
l = (2*l1 + lP)'*Pemp/3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%     INCOME    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
logy1 = mu_yP + log(data(:,7));
logy2 = mu_yP + log(data(:,8));%for the second kid, not period!
%not logged
y1units = data(:,7)*exp(mu_yP);
meany1units = y1units'*Pemp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%   second period junk   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%logged second period's allocations
y_21 = mu_yP + log(y_21);
%y_22 = mu_yP + log(y_22);

%generate the probability matrix, seems the same as in code3.m
P2 = kron(Pemp, ones(1, N)).*(kron(ones(N*NA,1),kron(T, ones(N,1))));
%meany_21 = sum(sum(P2.*y_21));
%vary_21 = sum(sum(P2.*(y_21-meany_21).^2));

%expected income in period 2
ey_21 = sum(P2.*exp(y_21),2)./sum(P2,2);
%ey_22 = sum(P2.*exp(y_22),2)./sum(P2,2);%this looks wrong, should have different P2, because we take the second kid, not the first one now
meanyperiod2 = ey_21'*Pemp;


%matrix of first period's income for regression
%y_11 = kron(logy1, ones(1,N));
%cov12 = sum(sum((y_21 - meany_21).*(y_11 - muy1).*P2));
%rhoyL = cov12/vary1;

bprimeunits = bprime.*exp(mu_yP);
%size(P2)
ebprimeunits = sum(P2.*bprimeunits,2)./sum(P2,2);
meanbprimeunits = ebprimeunits'*Pemp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%         TRUE GIFTS        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%s1 = exp(- 4.6971 + 1.1489*logy1);
%s2 = exp(- 4.6971 + 1.1489*logy2);

s1 = exp(-9.8624 + 1.5460*logy1);
s2 = exp(-9.8624 + 1.5460*logy2);


g1units = data(:,10)*exp(mu_yP) + s1/R;
g2units = data(:,11)*exp(mu_yP) + s2/R;
gdif = g1units - g2units;

mug = (g1units + g2units)'/2*Pemp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% "TRUE BEQUESTS" %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
beq1 = data(:,12)*exp(mu_yP); 
beq2 = data(:,13)*exp(mu_yP);

trueb1 = (beq1 - s1)/R;
trueb2 = (beq2 - s2)/R;
meantrueb = (trueb1 + trueb2)/2;

beqdif = trueb1-trueb2;

truelogb1 = log(trueb1);
truelogb2 = log(trueb2);

meanb = trueb1'*Pemp;
%meanbprimeunits/R
%meanyperiod2

%mug/meany1units;
%meanb/meany1units;

calib4 = [l-1/3,meanb/meany1units - 0.0222, mug/meany1units - 0.0065, meanbprimeunits/meanyperiod2/R - 0.0393];
% calib4 = [l-1/3,meanb/meany1units - 0.0222, mug/meany1units - 0.0065, meanbprimeunits/meanyperiod2/R - 0.0304];
