function calibbeta = calibbeta(x)

global Z1 A u up v vp W W_b N T TG TL mu_yP eta ZP zP Z1mat Z2mat grid_A R beta Z2 P PP phi N2 NA N policies data Pemp y_21 y_22 mures l phi1 %S1 S2 alpha
x;
phi = x(1);
eta = x(2);
beta = x(3);

k = 1;
%first best
x0 = .1*ones(3*N^2+N*(N+1)/2+ N*(N+1), 1);
%x0 = .1*ones(3*N^2+N*(N+1)/2+N*(N+1), 1);
%length(x0)

tic;

for j = 1:N
        P = TG(j,:)'; %column vector of probabilities for kids' types
        zP = ZP(j);
        
        Z1 = Z1mat(j,:)';
        Z2 = Z2mat(j,:)';
        
    for i = 1: NA
        A = grid_A(i);

        
        %if k < 2
        x0 = policies(:, k);
        %x0 = [x0(1: 3*N^2+N*(N+1)/2);x0(3*N^2+N*(N+1)/2+N-1+1: 3*N^2+N*(N+1)/2+N-1 + N*(N+1))];
        %end
    
        %options = optimset('display', 'iter', 'tolfun', 10^(-5), 'tolX', 10^(-5), 'maxfunevals', 1000000, 'maxiter', 1000000,'largescale', 'on');
        %options = optimset('display', 'iter','tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'NonlEqnAlgorithm', 'gn'); 
        options = optimset('display', 'iter','tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000,'maxiter', 1000000);%
           
        x = fsolve(@systemfb, x0, options);
        %sum(sum(abs(systemnew(x))))
                   
        if sum(sum(abs(systemfb(x))))>10^-5
           display 'we did not solve the system'
        end
        
        
        policies(:, k) = x; 
    
        %if k==1
        %    save ('x0','x0')
        %end

        %toc;
       
        %generate some output :-)
   
        %need to generate the extra states (i.e. have only (1,2), need also (2,1))
        cP = x(3*N^2+N*(N+1)/2 + 1: 3*N^2+N*(N+1)/2+ N*(N+1)/2);
        yP = x(3*N^2+N*(N+1)/2 + N*(N+1)/2 + 1: 3*N^2+N*(N+1)/2 + N*(N+1));
        lambda = x(3*N^2+1: 3*N^2+N*(N+1)/2);
        cPres = zeros(N,N);
        yPres = zeros(N,N);
        lres = zeros(N,N);
        
        for n = 1:N
            cPres(n, 1:n) = cP(n*(n-1)/2+1:n*(n+1)/2)';
            cPres(1:n, n) = cP(n*(n-1)/2+1:n*(n+1)/2);
            yPres(n, 1:n) = yP(n*(n-1)/2+1:n*(n+1)/2)';
            yPres(1:n, n) = yP(n*(n-1)/2+1:n*(n+1)/2);
            lres(n, 1:n) = lambda(n*(n-1)/2+1:n*(n+1)/2)';
            lres(1:n, n) = lambda(n*(n-1)/2+1:n*(n+1)/2);
        end
    
        cPres = reshape(cPres, N^2, 1);
        yPres = reshape(yPres, N^2, 1);
        lres = reshape(lres, N^2, 1);
        
        b1 = x(2*N^2+1:3*N^2);
        walue1 = W(b1, T);
        walue1 = walue1(1:N^2);
        
        %RECOVER AND TRANSFORM INTO MATRICES
        c1       = reshape(x(1:N^2), N, N); 
        y1       = reshape(x(N^2+1:2*N^2), N, N);
        b1       = reshape(x(2*N^2+1:3*N^2), N, N);
        walue1   = reshape(walue1, N, N);
        
        %define c2 by symmetry
        c2 = c1';
        y2 = y1';
        b2 = b1';
        walue2 = walue1';
        
        beqmat((k-1)*N+1:k*N,:) = b1'; %bequest matrix to compare to Kevin's?
        
        %convert back into vectors
        c1 = x(1:N^2);
        y1 = x(N^2+1:2*N^2);
        b1 = x(2*N^2+1:3*N^2);
        walue1 = reshape(walue1, N^2, 1);
        
        c2 = reshape(c2, N^2, 1);
        y2 = reshape(y2, N^2, 1);
        b2 = reshape(b2, N^2, 1);
        walue2 = reshape(walue2, N^2, 1);
        
        g1 = c1 - y1;
        g2 = c2 - y2;
    
        %I guess walue2 wrong because wrong transition vectors used
        %walue1 = W(b1, T);
        %walue2 = W(b2, T);
        %walue1 = walue1(1:N^2);
        %walue2 = walue2(1:N^2);
        
        
        walue = u(cPres) - phi*v(yPres/zP) + eta*(u(c1) - phi*v(y1./kron(Z1, ones(N,1))) + beta*walue1+...
            + u(c2) - phi*v(y2./kron(ones(N,1), Z1)) + beta*walue2);
        V(k, :) = [sum(walue)/N^2,sum(lres)]; %careful here, need uniform on Z1
       
        %the probability of a given entry
        totP = PP(j,i)*ones(N^2,1).*kron(P, ones(N,1)).*kron(ones(N,1), P);
        Z11vector((k-1)*N^2+1:k*N^2) = [kron(Z1,ones(N,1))];%vector of first kid's types
        data((k-1)*N^2+1:k*N^2, :) = [A*ones(N^2,1), zP*ones(N^2,1), totP, c1, c2, cPres, y1, y2, yPres, g1, g2, b1, b2, walue1, walue2, walue, lres];
        
        %check the IC's in a separate function
        %min(min(IC(x)))
        %the new system is not yet adjusted to this
        %IC(x);
    
        %second period's allocations
        output21 = output2(b1);
        output22 = output2(b2);
        y_21((k-1)*N2^2+1:k*N2^2, :) = output21(1:N^2,:);
        y_22((k-1)*N2^2+1:k*N2^2, :) = output22(1:N^2,:);
        %c_21((k-1)*N2^2+1:k*N2^2, :) = output21(1+N^2:2*N^2,:);
        %c_22((k-1)*N2^2+1:k*N2^2, :) = output22(1+N^2:2*N^2,:);

        %in MATLAB7, seems this is needed
        %save('C:\Documents and Settings\Ctirad\My Documents\Minnesota\Research\Kevin & I\Bequests\2 pd, many shock\Ctirad with parents\policies','policies') %to have always the new numbers in
        %save('policiesFB1_2_2_10states','policies') %to have always the new numbers in
        %save('policiesFB','policies') %to have always the new numbers in
        k = k+1;
        
        %initial guess for next asset value and the same parents' productivity
        x0 = x;
        
    end
    x0 = policies(:, 1+(j-1)*NA); %use the guess from the same asset level when going to next productivity level
    
end

 save V V
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%     LABOR    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%define the probability
Pemp = data(:,3);
%labor of kid 1
l1 = data(:,7)./Z11vector';
%labor of parent
lP = data(:,9)./data(:,2);
l = (2*l1 + lP)'*Pemp/3;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%     INCOME    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
logy1 = mu_yP + log(data(:,7));
logy2 = mu_yP + log(data(:,8));%for the second kid, not period!
%not logged
y1units = data(:,7)*exp(mu_yP);
meany1units = y1units'*Pemp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%         TRUE GIFTS        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%s1 = exp(- 4.6971 + 1.1489*logy1);
%s2 = exp(- 4.6971 + 1.1489*logy2);

s1 = exp(-9.8624 + 1.5460*logy1);
s2 = exp(-9.8624 + 1.5460*logy2);


g1units = data(:,10)*exp(mu_yP) + s1/R;
g2units = data(:,11)*exp(mu_yP) + s2/R;
gdif = g1units - g2units;

mug = (g1units + g2units)'/2*Pemp;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%% "TRUE BEQUESTS" %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
beq1 = data(:,12)*exp(mu_yP); 
beq2 = data(:,13)*exp(mu_yP);

trueb1 = (beq1 - s1)/R;
trueb2 = (beq2 - s2)/R;
meantrueb = (trueb1 + trueb2)/2;

beqdif = trueb1-trueb2;

truelogb1 = log(trueb1);
truelogb2 = log(trueb2);

meanb = trueb1'*Pemp;

%mug/meany1units;
%meanb/meany1units;

calibbeta = [l-1/3,meanb/meany1units - 0.0222, mug/meany1units - 0.0065];
