%this calculates allocations in the next period

function output2dyn = output2dyn(b)
global sigma gamma u up v vp Z2 phi phi1 phi2 R

z = Z2;
extra = (R*phi1)^(1/sigma)/R;
bmat = b*ones(1, length(z));
zmat = (z*ones(1, length(b)))';

if sigma == gamma
   c = (bmat+phi2/R + ((bmat+phi2/R).^2 + 4*(1+extra)/phi^(1/gamma)*zmat.^((gamma+1)/gamma)).^.5)/(2*(1+extra));
   bprime = (R*phi1)^(1/sigma)*c - phi2;
else
display 'this only works for equal sigma = gamma buddy!'
end
output2dyn = [c - bmat+bprime/R; c; bprime];