function pictures = pictures(x)

global Pivector

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%PLOTTING THE POLICIES S FUNCTIONS OF Pi%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

c_L      = x(1,:);
c_H      = x(2,:);
y_L      = x(3,:);
y_H      = x(4,:);
b_L      = x(5,:);
b_H      = x(6,:);
g_L      = c_L - y_L;
g_H      = c_H - y_H;
t_L      = b_L + g_L;
t_H      = b_H + g_H;
lambda   = x(7,:);
mu       = x(8,:);
z        = Pivector;

figure(1)
subplot(2,2,1),
plot(z, c_L, 'b',z, c_H, 'g','LineWidth',2)
title('Parameter values: z_H = 2, z_L = 1, A = 2')
xlabel('Pi')
ylabel('consumption')
legend('c_L', 'c_H')

subplot(2,2,2),
plot(z, y_L, 'b', z, y_H, 'g','LineWidth',2)
xlabel('Pi')
ylabel('output')
legend('y_L', 'y_H')

subplot(2,2,3),
plot(z, mu, 'b','LineWidth',2)
xlabel('Pi')
ylabel('\mu')
legend('\mu')

subplot(2,2,4),
plot(z, lambda, 'b','LineWidth',2)
xlabel('Pi')
ylabel('\lambda')
legend('\lambda')

figure(2)
subplot(2,2,1),
plot(z, b_L, 'b', z, b_H, 'g','LineWidth',2)
title('Parameter values: z_H = 2, z_L = 1, A = 2')
xlabel('Pi')
ylabel('bequests')
legend('b_L', 'b_H')

subplot(2,2,2),
plot(z, g_L, 'b', z, g_H, 'g','LineWidth',2)
xlabel('Pi')
ylabel('gifts')
legend('g_L', 'g_H')

subplot(2,2,3),
plot(z, t_L, 'b', z, t_H, 'g','LineWidth',2)
xlabel('Pi')
ylabel('overall transfers')
legend('t_L', 't_H')
