%this is the continuation value

function wnew = wnew(b)
global sigma gamma u up v vp Z2 phi k
z = Z2;

%think about the initial guess
N = length(z);
bmat = b*ones(1, length(z));
zmat = (z*ones(1, length(b)))';

if sigma == gamma
    c = (bmat + (bmat.^2 + 4/phi^(1/gamma)*zmat.^((gamma+1)/gamma)).^.5)/2;
else
    %c0 = bmat+1/3*zmat;  %pretty bad guess, plus it is used all over again, could/should be improved
    %c0 = bmat + (zmat.^(1+gamma)/phi).^(1/(gamma+sigma)); %this is true for b = 0
    %load cprime cprime
    %c0 = cprime(:,:,k);
    %check = up(c0) - phi*vp((c0-bmat)./zmat)./zmat;
    %if check ~= real(check)
    %    blah
    %end
    %c0 = (bmat + (bmat.^2 + 4/phi^(1/gamma)*zmat.^((gamma+1)/gamma)).^.5)/2; %this c is always positive and also y
    options = optimset('display', 'off', 'tolfun', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'FunValCheck', 'on'); 
    %options = optimset('display', 'off','tolfun', 10^(-10), 'tolX', 10^(-10), 'maxfunevals', 1000000, 'maxiter', 1000000, 'NonlEqnAlgorithm', 'gn'); 
    %c=fsolve(@(c) up(c) - phi*vp((c-bmat)./zmat)./zmat, c0, options);
    ctilde0 = log((bmat + (bmat.^2 + 4/phi^(1/gamma)*zmat.^((gamma+1)/gamma)).^.5)/2); %this c is always positive and also y
    ytilde0 = log(exp(ctilde0) - bmat);
    sysW = @(xx) [up(exp(xx(1:N^2,:))) - phi*vp((exp(xx(N^2+1:2*N^2,:)))./zmat)./zmat; exp(xx(1:N^2,:))-exp(xx(N^2+1:2*N^2,:)) - bmat];
    xxout = fsolve(sysW, [ctilde0; ytilde0], options);

   
    %c = bmat+1/3*zmat; %fixing labor in the second period
    %c0 = c;
    %save c0 c0
    %check = sum(sum(up(c) - phi*vp((c-bmat)./zmat)./zmat))
    c = exp(xxout(1:N^2,:));
end
%load cprime cprime
%load yprime yprime
%cprime(:,:,k) = c;
%yprime(:,:,k) = c - bmat;
%save cprime cprime
%save yprime yprime

wnew = [u(c) - phi*v((c-bmat)./zmat); up(c)];