***********************************
*The STATA code is generated automatically
*****************************
* Created by Jun Li
* junli.econ@gmail.com
***********************************
set more off 
clear all
cd ~/Work/Ctirad/PSID/Bequests/Data
use Data_raw_current.dta, clear 
gen identifier = 1000*ER30001 + ER30002
gen FatherPN = ER32017
gen MotherPN = ER32010
rename V3 IW1968
rename V117 AgeHead1968
rename V118 AgeWife1968
rename V534 ID1969
rename V74 HeadTotalWage1968
rename V251 HeadWage1968
rename V75 WifeTotalWage1968
rename V21807 WifeTotalWageExcludeBusi1993
rename V21806 WifeBusiness1993
rename V266 Transfer1968
rename V267 SrcOfTransfer1968
rename V15771 Inheritance1988
rename V22172 NonrelativeHead1993
rename V22158 NonrelativeHeadReport1993
rename V22159 NonrelativeHeadReportUnit1993
rename V22349 NonrelativeWife1993
rename V22335 NonrelativeWifeReport1993
rename V22336 NonrelativeWifeReportUnit1993
rename V262 RelativeHead1968
rename V22142 RelativeHeadReport1993
rename V22143 RelativeHeadReportUnit1993
rename V11457 RelativeWife1985
rename V22319 RelativeWifeReport1993
rename V22320 RelativeWifeReportUnit1993
rename V47 HeadHours1968
rename V53 WifeHours1968
rename V1190 HeadBusi1970
rename V337 HeadWageHour1968
rename V338 WifeWageHour1968
rename ER30003 Relation1968
rename ER30021 SequenceNum1969
rename V119 SexHead1968
rename V451 PrincipalRem1969
rename S116 WealthExclH1984
rename S117 WealthInclH1984
rename V93 State1968
rename V181 RaceHD1st1968
rename V11939 RaceHD2nd1985
rename ER3946 RaceHD3rd1994
rename ER11851 RaceHD4th1997
rename V362 RegionGrowHD1968
rename ER30010 Education1968

rename V442 IW1969
rename V1008 AgeHead1969
rename V1011 AgeWife1969
rename V1230 ID1970
rename V514 HeadTotalWage1969
rename V699 HeadWage1969
rename V516 WifeTotalWage1969
rename ER4144 WifeTotalWageExcludeBusi1994
rename ER4141 WifeBusiness1994
rename V719 Transfer1969
rename V17306 Inheritance1989
rename ER27978 NonrelativeHead2005
rename ER3446 NonrelativeHeadReport1994
rename ER3447 NonrelativeHeadReportUnit1994
rename ER27998 NonrelativeWife2005
rename ER3674 NonrelativeWifeReport1994
rename ER3675 NonrelativeWifeReportUnit1994
rename V710 RelativeHead1969
rename ER3431 RelativeHeadReport1994
rename ER3432 RelativeHeadReportUnit1994
rename V12864 RelativeWife1986
rename ER3659 RelativeWifeReport1994
rename ER3660 RelativeWifeReportUnit1994
rename V465 HeadHours1969
rename V475 WifeHours1969
rename V1891 HeadBusi1971
rename V871 HeadWageHour1969
rename V873 WifeWageHour1969
rename ER30022 Relation1969
rename ER30044 SequenceNum1970
rename V1010 SexHead1969
rename V1124 PrincipalRem1970
rename S216 WealthExclH1989
rename S217 WealthInclH1989
rename V537 State1969
rename V801 RaceHD1st1969
rename V13566 RaceHD2nd1986
rename ER6816 RaceHD3rd1995
rename ER15931 RaceHD4th1999
rename V877 RegionGrowHD1969
rename ER30052 Education1970

rename V1102 IW1970
rename V1239 AgeHead1970
rename V1241 AgeWife1970
rename V1932 ID1971
rename V1196 HeadTotalWage1970
rename V1191 HeadWage1970
rename V1198 WifeTotalWage1970
rename ER6984 WifeTotalWageExcludeBusi1995
rename ER6981 WifeBusiness1995
rename V1385 Transfer1970
rename V18710 Inheritance1990
rename ER40968 NonrelativeHead2007
rename ER6447 NonrelativeHeadReport1995
rename ER6448 NonrelativeHeadReportUnit1995
rename ER40988 NonrelativeWife2007
rename ER6676 NonrelativeWifeReport1995
rename ER6677 NonrelativeWifeReportUnit1995
rename V1216 RelativeHead1970
rename ER6432 RelativeHeadReport1995
rename ER6433 RelativeHeadReportUnit1995
rename V13966 RelativeWife1987
rename ER6661 RelativeWifeReport1995
rename ER6662 RelativeWifeReportUnit1995
rename V1138 HeadHours1970
rename V1148 WifeHours1970
rename V2492 HeadBusi1972
rename V1567 HeadWageHour1970
rename V1569 WifeWageHour1970
rename ER30045 Relation1970
rename ER30068 SequenceNum1971
rename V1240 SexHead1970
rename V1825 PrincipalRem1971
rename S316 WealthExclH1994
rename S317 WealthInclH1994
rename V1103 State1970
rename V1490 RaceHD1st1970
rename V14613 RaceHD2nd1987
rename ER9062 RaceHD3rd1996
rename ER19992 RaceHD4th2001
rename V1573 RegionGrowHD1970
rename ER30076 Education1971

rename V1802 IW1971
rename V1942 AgeHead1971
rename V1944 AgeWife1971
rename V2533 ID1972
rename V1897 HeadTotalWage1971
rename V1892 HeadWage1971
rename V1899 WifeTotalWage1971
rename ER9235 WifeTotalWageExcludeBusi1996
rename ER9232 WifeBusiness1996
rename V2097 Transfer1971
rename V20010 Inheritance1991
rename ER46876 NonrelativeHead2009
rename ER8564 NonrelativeHeadReport1996
rename ER8565 NonrelativeHeadReportUnit1996
rename ER46896 NonrelativeWife2009
rename ER8793 NonrelativeWifeReport1996
rename ER8794 NonrelativeWifeReportUnit1996
rename V1918 RelativeHead1971
rename ER8549 RelativeHeadReport1996
rename ER8550 RelativeHeadReportUnit1996
rename V14981 RelativeWife1988
rename ER8778 RelativeWifeReport1996
rename ER8779 RelativeWifeReportUnit1996
rename V1839 HeadHours1971
rename V1849 WifeHours1971
rename V3045 HeadBusi1973
rename V2279 HeadWageHour1971
rename V2281 WifeWageHour1971
rename ER30069 Relation1971
rename ER30092 SequenceNum1972
rename V1943 SexHead1971
rename V2425 PrincipalRem1972
rename S416 WealthExclH1999
rename S417 WealthInclH1999
rename V1803 State1971
rename V2202 RaceHD1st1971
rename V16087 RaceHD2nd1988
rename ER11850 RaceHD3rd1997
rename ER23429 RaceHD4th2003
rename V2285 RegionGrowHD1971
rename ER30100 Education1972

rename V2402 IW1972
rename V2542 AgeHead1972
rename V2544 AgeWife1972
rename V3085 ID1973
rename V2498 HeadTotalWage1972
rename V2493 HeadWage1972
rename V2500 WifeTotalWage1972
rename ER12082 WifeTotalWageExcludeBusi1997
rename ER12214 WifeBusiness1997
rename V2703 Transfer1972
rename V21310 Inheritance1992
rename ER52284 NonrelativeHead2011
rename ER11458 NonrelativeHeadReport1997
rename ER11459 NonrelativeHeadReportUnit1997
rename ER52304 NonrelativeWife2011
rename ER11675 NonrelativeWifeReport1997
rename ER11676 NonrelativeWifeReportUnit1997
rename V2519 RelativeHead1972
rename ER11443 RelativeHeadReport1997
rename ER11444 RelativeHeadReportUnit1997
rename V16481 RelativeWife1989
rename ER11660 RelativeWifeReport1997
rename ER11661 RelativeWifeReportUnit1997
rename V2439 HeadHours1972
rename V2449 WifeHours1972
rename V3457 HeadBusi1974
rename V2906 HeadWageHour1972
rename V2908 WifeWageHour1972
rename ER30093 Relation1972
rename ER30118 SequenceNum1973
rename V2543 SexHead1972
rename V4320 PrincipalRem1976
rename S516 WealthExclH2001
rename S517 WealthInclH2001
rename V2403 State1972
rename V2828 RaceHD1st1972
rename V17484 RaceHD2nd1989
rename ER15930 RaceHD3rd1999
rename ER27396 RaceHD4th2005
rename V2912 RegionGrowHD1972
rename ER30126 Education1973

rename V3002 IW1973
rename V3095 AgeHead1973
rename V3097 AgeWife1973
rename V3497 ID1974
rename V3051 HeadTotalWage1973
rename V3046 HeadWage1973
rename V3053 WifeTotalWage1973
rename ER16465 WifeTotalWageExcludeBusi1999
rename ER16511 WifeBusiness1999
rename V3210 Transfer1973
rename V23169 Inheritance1993
rename ER58087 NonrelativeHead2013
rename ER14724 NonrelativeHeadReport1999
rename ER14725 NonrelativeHeadReportUnit1999
rename ER58113 NonrelativeWife2013
rename ER14941 NonrelativeWifeReport1999
rename ER14942 NonrelativeWifeReportUnit1999
rename V3072 RelativeHead1973
rename ER14709 RelativeHeadReport1999
rename ER14710 RelativeHeadReportUnit1999
rename V17897 RelativeWife1990
rename ER14926 RelativeWifeReport1999
rename ER14927 RelativeWifeReportUnit1999
rename V3027 HeadHours1973
rename V3035 WifeHours1973
rename V3857 HeadBusi1975
rename V3275 HeadWageHour1973
rename V3277 WifeWageHour1973
rename ER30119 Relation1973
rename ER30139 SequenceNum1974
rename V3096 SexHead1973
rename V5219 PrincipalRem1977
rename S616 WealthExclH2003
rename S617 WealthInclH2003
rename V3003 State1973
rename V3300 RaceHD1st1973
rename V18815 RaceHD2nd1990
rename ER19991 RaceHD3rd2001
rename ER40568 RaceHD4th2007
rename V3280 RegionGrowHD1973
rename ER30147 Education1974

rename V3402 IW1974
rename V3508 AgeHead1974
rename V3510 AgeWife1974
rename V3909 ID1975
rename V3463 HeadTotalWage1974
rename V3458 HeadWage1974
rename V3465 WifeTotalWage1974
rename ER20447 WifeTotalWageExcludeBusi2001
rename ER20444 WifeBusiness2001
rename V3629 Transfer1974
rename ER3704 Inheritance1994
rename ER18895 NonrelativeHeadReport2001
rename ER18896 NonrelativeHeadReportUnit2001
rename ER19127 NonrelativeWifeReport2001
rename ER19128 NonrelativeWifeReportUnit2001
rename V3484 RelativeHead1974
rename ER18879 RelativeHeadReport2001
rename ER18880 RelativeHeadReportUnit2001
rename V19197 RelativeWife1991
rename ER19111 RelativeWifeReport2001
rename ER19112 RelativeWifeReportUnit2001
rename V3423 HeadHours1974
rename V3431 WifeHours1974
rename V4372 HeadBusi1976
rename V3695 HeadWageHour1974
rename V3697 WifeWageHour1974
rename ER30140 Relation1974
rename ER30161 SequenceNum1975
rename V3509 SexHead1974
rename V5719 PrincipalRem1978
rename S716 WealthExclH2005
rename S717 WealthInclH2005
rename V3403 State1974
rename V3720 RaceHD1st1974
rename V20115 RaceHD2nd1991
rename ER23428 RaceHD3rd2003
rename ER46546 RaceHD4th2009
rename V3700 RegionGrowHD1974
rename ER30169 Education1975

rename V3802 IW1975
rename V3921 AgeHead1975
rename V3923 AgeWife1975
rename V4423 ID1976
rename V3863 HeadTotalWage1975
rename V3858 HeadWage1975
rename V3865 WifeTotalWage1975
rename ER24135 WifeTotalWageExcludeBusi2003
rename ER24111 WifeBusiness2003
rename V4075 Transfer1975
rename ER6706 Inheritance1995
rename ER22265 NonrelativeHeadReport2003
rename ER22266 NonrelativeHeadReportUnit2003
rename ER22500 NonrelativeWifeReport2003
rename ER22501 NonrelativeWifeReportUnit2003
rename V3885 RelativeHead1975
rename ER22249 RelativeHeadReport2003
rename ER22250 RelativeHeadReportUnit2003
rename V20497 RelativeWife1992
rename ER22484 RelativeWifeReport2003
rename ER22485 RelativeWifeReportUnit2003
rename V3823 HeadHours1975
rename V3831 WifeHours1975
rename V5282 HeadBusi1977
rename V4174 HeadWageHour1975
rename V4176 WifeWageHour1975
rename ER30162 Relation1975
rename ER30189 SequenceNum1976
rename V3922 SexHead1975
rename V6321 PrincipalRem1979
rename S816 WealthExclH2007
rename S817 WealthInclH2007
rename V3803 State1975
rename V4204 RaceHD1st1975
rename V21421 RaceHD2nd1992
rename ER27395 RaceHD3rd2005
rename ER51907 RaceHD4th2011
rename V4179 RegionGrowHD1975
rename ER30197 Education1976

rename V4302 IW1976
rename V4436 AgeHead1976
rename V4438 AgeWife1976
rename V5336 ID1977
rename V5031 HeadTotalWage1976
rename V4373 HeadWage1976
rename V4379 WifeTotalWage1976
rename ER27943 WifeTotalWageExcludeBusi2005
rename ER27940 WifeBusiness2005
rename V4619 Transfer1976
rename ER8824 Inheritance1996
rename ER26246 NonrelativeHeadReport2005
rename ER26247 NonrelativeHeadReportUnit2005
rename ER26481 NonrelativeWifeReport2005
rename ER26482 NonrelativeWifeReportUnit2005
rename V4399 RelativeHead1976
rename ER26230 RelativeHeadReport2005
rename ER26231 RelativeHeadReportUnit2005
rename V22333 RelativeWife1993
rename ER26465 RelativeWifeReport2005
rename ER26466 RelativeWifeReportUnit2005
rename V4332 HeadHours1976
rename V4344 WifeHours1976
rename V5781 HeadBusi1978
rename V5050 HeadWageHour1976
rename V5052 WifeWageHour1976
rename ER30190 Relation1976
rename ER30218 SequenceNum1977
rename V4437 SexHead1976
rename V6919 PrincipalRem1980
rename ER46968 WealthExclH2009
rename ER46970 WealthInclH2009
rename V4303 State1976
rename V5096 RaceHD1st1976
rename V23277 RaceHD2nd1993
rename ER40567 RaceHD3rd2007
rename ER57662 RaceHD4th2013
rename V5055 RegionGrowHD1976
rename ER30226 Education1977

rename V5202 IW1977
rename V5350 AgeHead1977
rename V5352 AgeWife1977
rename V5835 ID1978
rename V5627 HeadTotalWage1977
rename V5283 HeadWage1977
rename V5289 WifeTotalWage1977
rename ER40933 WifeTotalWageExcludeBusi2007
rename ER40930 WifeBusiness2007
rename V5554 Transfer1977
rename ER11706 Inheritance1997
rename ER37264 NonrelativeHeadReport2007
rename ER37265 NonrelativeHeadReportUnit2007
rename ER37499 NonrelativeWifeReport2007
rename ER37500 NonrelativeWifeReportUnit2007
rename V5311 RelativeHead1977
rename ER37248 RelativeHeadReport2007
rename ER37249 RelativeHeadReportUnit2007
rename ER27996 RelativeWife2005
rename ER37483 RelativeWifeReport2007
rename ER37484 RelativeWifeReportUnit2007
rename V5232 HeadHours1977
rename V5244 WifeHours1977
rename V6390 HeadBusi1979
rename V5631 HeadWageHour1977
rename V5632 WifeWageHour1977
rename ER30219 Relation1977
rename ER30247 SequenceNum1978
rename V5351 SexHead1977
rename V7519 PrincipalRem1981
rename ER52392 WealthExclH2011
rename ER52394 WealthInclH2011
rename V5203 State1977
rename V5662 RaceHD1st1977
rename ER3945 RaceHD2nd1994
rename ER46545 RaceHD3rd2009
rename V5634 RegionGrowHD1977
rename ER30255 Education1978

rename V5702 IW1978
rename V5850 AgeHead1978
rename V5852 AgeWife1978
rename V6446 ID1979
rename V6174 HeadTotalWage1978
rename V5782 HeadWage1978
rename V5788 WifeTotalWage1978
rename ER46841 WifeTotalWageExcludeBusi2009
rename ER46838 WifeBusiness2009
rename V6096 Transfer1978
rename ER14972 Inheritance1999
rename ER43255 NonrelativeHeadReport2009
rename ER43256 NonrelativeHeadReportUnit2009
rename ER43490 NonrelativeWifeReport2009
rename ER43491 NonrelativeWifeReportUnit2009
rename V5811 RelativeHead1978
rename ER43239 RelativeHeadReport2009
rename ER43240 RelativeHeadReportUnit2009
rename ER40986 RelativeWife2007
rename ER43474 RelativeWifeReport2009
rename ER43475 RelativeWifeReportUnit2009
rename V5731 HeadHours1978
rename V5743 WifeHours1978
rename V6980 HeadBusi1980
rename V6178 HeadWageHour1978
rename V6179 WifeWageHour1978
rename ER30248 Relation1978
rename ER30284 SequenceNum1979
rename V5851 SexHead1978
rename V8819 PrincipalRem1983
rename ER58209 WealthExclH2013
rename ER58211 WealthInclH2013
rename V5703 State1978
rename V6209 RaceHD1st1978
rename ER6815 RaceHD2nd1995
rename ER51906 RaceHD3rd2011
rename V6181 RegionGrowHD1978
rename ER30296 Education1979

rename V6302 IW1979
rename V6462 AgeHead1979
rename V6464 AgeWife1979
rename V7050 ID1980
rename V6767 HeadTotalWage1979
rename V6391 HeadWage1979
rename V6398 WifeTotalWage1979
rename ER52249 WifeTotalWageExcludeBusi2011
rename ER52246 WifeBusiness2011
rename V6689 Transfer1979
rename ER19160 Inheritance2001
rename ER48580 NonrelativeHeadReport2011
rename ER48581 NonrelativeHeadReportUnit2011
rename ER48815 NonrelativeWifeReport2011
rename ER48816 NonrelativeWifeReportUnit2011
rename V6422 RelativeHead1979
rename ER48564 RelativeHeadReport2011
rename ER48565 RelativeHeadReportUnit2011
rename ER46894 RelativeWife2009
rename ER48799 RelativeWifeReport2011
rename ER48800 RelativeWifeReportUnit2011
rename V6336 HeadHours1979
rename V6348 WifeHours1979
rename V7572 HeadBusi1981
rename V6771 HeadWageHour1979
rename V6772 WifeWageHour1979
rename ER30285 Relation1979
rename ER30314 SequenceNum1980
rename V6463 SexHead1979
rename V10020 PrincipalRem1984
rename V6303 State1979
rename V6802 RaceHD1st1979
rename ER9061 RaceHD2nd1996
rename ER57661 RaceHD3rd2013
rename V6774 RegionGrowHD1979
rename ER30326 Education1980

rename V6902 IW1980
rename V7067 AgeHead1980
rename V7069 AgeWife1980
rename V7642 ID1981
rename V7413 HeadTotalWage1980
rename V6981 HeadWage1980
rename V6988 WifeTotalWage1980
rename ER58050 WifeTotalWageExcludeBusi2013
rename ER58047 WifeBusiness2013
rename V7292 Transfer1980
rename ER22533 Inheritance2003
rename ER54274 NonrelativeHeadReport2013
rename ER54275 NonrelativeHeadReportUnit2013
rename ER54558 NonrelativeWifeReport2013
rename ER54559 NonrelativeWifeReportUnit2013
rename V7012 RelativeHead1980
rename ER54258 RelativeHeadReport2013
rename ER54259 RelativeHeadReportUnit2013
rename ER52302 RelativeWife2011
rename ER54542 RelativeWifeReport2013
rename ER54543 RelativeWifeReportUnit2013
rename V6934 HeadHours1980
rename V6946 WifeHours1980
rename V8264 HeadBusi1982
rename V7417 HeadWageHour1980
rename V7418 WifeWageHour1980
rename ER30315 Relation1980
rename ER30344 SequenceNum1981
rename V7068 SexHead1980
rename V11127 PrincipalRem1985
rename V6903 State1980
rename V7447 RaceHD1st1980
rename ER11849 RaceHD2nd1997
rename V7420 RegionGrowHD1980
rename ER30356 Education1981

rename V7502 IW1981
rename V7658 AgeHead1981
rename V7660 AgeWife1981
rename V8335 ID1982
rename V8066 HeadTotalWage1981
rename V7573 HeadWage1981
rename V7580 WifeTotalWage1981
rename V7992 Transfer1981
rename ER26514 Inheritance2005
rename V7604 RelativeHead1981
rename ER58111 RelativeWife2013
rename V7530 HeadHours1981
rename V7540 WifeHours1981
rename V8872 HeadBusi1983
rename V8069 HeadWageHour1981
rename V8070 WifeWageHour1981
rename ER30345 Relation1981
rename ER30374 SequenceNum1982
rename V7659 SexHead1981
rename V12526 PrincipalRem1986
rename V7503 State1981
rename V8099 RaceHD1st1981
rename ER15929 RaceHD2nd1999
rename V8072 RegionGrowHD1981
rename ER30384 Education1982

rename V8202 IW1982
rename V8352 AgeHead1982
rename V8354 AgeWife1982
rename V8943 ID1983
rename V8690 HeadTotalWage1982
rename V8265 HeadWage1982
rename V8273 WifeTotalWage1982
rename V8611 Transfer1982
rename ER37532 Inheritance2007
rename V8297 RelativeHead1982
rename V8228 HeadHours1982
rename V8238 WifeHours1982
rename V10255 HeadBusi1984
rename V8693 HeadWageHour1982
rename V8694 WifeWageHour1982
rename ER30375 Relation1982
rename ER30400 SequenceNum1983
rename V8353 SexHead1982
rename V13726 PrincipalRem1987
rename V8203 State1982
rename V8723 RaceHD1st1982
rename ER19990 RaceHD2nd2001
rename V8696 RegionGrowHD1982
rename ER30413 Education1983

rename V8802 IW1983
rename V8961 AgeHead1983
rename V8963 AgeWife1983
rename V10400 ID1984
rename V9376 HeadTotalWage1983
rename V8873 HeadWage1983
rename V8881 WifeTotalWage1983
rename V9302 Transfer1983
rename ER43523 Inheritance2009
rename V8905 RelativeHead1983
rename V8830 HeadHours1983
rename V8840 WifeHours1983
rename V11396 HeadBusi1985
rename V9379 HeadWageHour1983
rename V9380 WifeWageHour1983
rename ER30401 Relation1983
rename ER30430 SequenceNum1984
rename V8962 SexHead1983
rename V14826 PrincipalRem1988
rename V8803 State1983
rename V9408 RaceHD1st1983
rename ER23427 RaceHD2nd2003
rename V9382 RegionGrowHD1983
rename ER30443 Education1984

rename V10002 IW1984
rename V10419 AgeHead1984
rename V10421 AgeWife1984
rename V11581 ID1985
rename V11023 HeadTotalWage1984
rename V10256 HeadWage1984
rename V10263 WifeTotalWage1984
rename V10893 Transfer1984
rename ER48848 Inheritance2011
rename V10300 RelativeHead1984
rename V10037 HeadHours1984
rename V10131 WifeHours1984
rename V12795 HeadBusi1986
rename V11026 HeadWageHour1984
rename V11027 WifeWageHour1984
rename ER30431 Relation1984
rename ER30464 SequenceNum1985
rename V10420 SexHead1984
rename V16326 PrincipalRem1989
rename V10003 State1984
rename V11055 RaceHD1st1984
rename ER27394 RaceHD2nd2005
rename V11029 RegionGrowHD1984
rename ER30478 Education1985

rename V11102 IW1985
rename V11606 AgeHead1985
rename V11608 AgeWife1985
rename V12988 ID1986
rename V12372 HeadTotalWage1985
rename V11397 HeadWage1985
rename V11404 WifeTotalWage1985
rename V11894 Transfer1985
rename ER54591 Inheritance2013
rename V11445 RelativeHead1985
rename V11146 HeadHours1985
rename V11258 WifeHours1985
rename V13897 HeadBusi1987
rename V12377 HeadWageHour1985
rename V12378 WifeWageHour1985
rename ER30465 Relation1985
rename ER30499 SequenceNum1986
rename V11607 SexHead1985
rename V17726 PrincipalRem1990
rename V11103 State1985
rename V11938 RaceHD1st1985
rename ER40566 RaceHD2nd2007
rename V12383 RegionGrowHD1985
rename ER30513 Education1986

rename V12502 IW1986
rename V13011 AgeHead1986
rename V13013 AgeWife1986
rename V14090 ID1987
rename V13624 HeadTotalWage1986
rename V12796 HeadWage1986
rename V12803 WifeTotalWage1986
rename V13405 Transfer1986
rename V12844 RelativeHead1986
rename V12545 HeadHours1986
rename V12657 WifeHours1986
rename V14912 HeadBusi1988
rename V13629 HeadWageHour1986
rename V13630 WifeWageHour1986
rename ER30500 Relation1986
rename ER30536 SequenceNum1987
rename V13012 SexHead1986
rename V19026 PrincipalRem1991
rename V12503 State1986
rename V13565 RaceHD1st1986
rename ER46544 RaceHD2nd2009
rename V13635 RegionGrowHD1986
rename ER30549 Education1987

rename V13702 IW1987
rename V14114 AgeHead1987
rename V14116 AgeWife1987
rename V15105 ID1988
rename V14671 HeadTotalWage1987
rename V13898 HeadWage1987
rename V13905 WifeTotalWage1987
rename V14502 Transfer1987
rename V13946 RelativeHead1987
rename V13745 HeadHours1987
rename V13809 WifeHours1987
rename V16412 HeadBusi1989
rename V14676 HeadWageHour1987
rename V14677 WifeWageHour1987
rename ER30537 Relation1987
rename ER30571 SequenceNum1988
rename V14115 SexHead1987
rename V20326 PrincipalRem1992
rename V13703 State1987
rename V14612 RaceHD1st1987
rename ER51905 RaceHD2nd2011
rename V14682 RegionGrowHD1987
rename ER30584 Education1988

rename V14802 IW1988
rename V15130 AgeHead1988
rename V15132 AgeWife1988
rename V16605 ID1989
rename V16145 HeadTotalWage1988
rename V14913 HeadWage1988
rename V14920 WifeTotalWage1988
rename V15770 Transfer1988
rename V14961 RelativeHead1988
rename V14835 HeadHours1988
rename V14865 WifeHours1988
rename V17828 HeadBusi1990
rename V16150 HeadWageHour1988
rename V16151 WifeWageHour1988
rename ER30572 Relation1988
rename ER30607 SequenceNum1989
rename V15131 SexHead1988
rename V21612 PrincipalRem1993
rename V14803 State1988
rename V16086 RaceHD1st1988
rename ER57660 RaceHD2nd2013
rename V16156 RegionGrowHD1988
rename ER30620 Education1989

rename V16302 IW1989
rename V16631 AgeHead1989
rename V16633 AgeWife1989
rename V18021 ID1990
rename V17534 HeadTotalWage1989
rename V16413 HeadWage1989
rename V16420 WifeTotalWage1989
rename V17305 Transfer1989
rename V16461 RelativeHead1989
rename V16335 HeadHours1989
rename V16365 WifeHours1989
rename V19128 HeadBusi1991
rename V17536 HeadWageHour1989
rename V17537 WifeWageHour1989
rename ER30608 Relation1989
rename ER30643 SequenceNum1990
rename V16632 SexHead1989
rename ER2037 PrincipalRem1994
rename V16303 State1989
rename V17483 RaceHD1st1989
rename V17542 RegionGrowHD1989
rename ER30657 Education1990

rename V17702 IW1990
rename V18049 AgeHead1990
rename V18051 AgeWife1990
rename V19321 ID1991
rename V18878 HeadTotalWage1990
rename V17829 HeadWage1990
rename V17836 WifeTotalWage1990
rename V18709 Transfer1990
rename V17877 RelativeHead1990
rename V17744 HeadHours1990
rename V17774 WifeHours1990
rename V20428 HeadBusi1992
rename V18887 HeadWageHour1990
rename V18888 WifeWageHour1990
rename ER30644 Relation1990
rename ER30690 SequenceNum1991
rename V18050 SexHead1990
rename ER5036 PrincipalRem1995
rename V17703 State1990
rename V18814 RaceHD1st1990
rename V18893 RegionGrowHD1990
rename ER30703 Education1991

rename V19002 IW1991
rename V19349 AgeHead1991
rename V19351 AgeWife1991
rename V20621 ID1992
rename V20178 HeadTotalWage1991
rename V19129 HeadWage1991
rename V19136 WifeTotalWage1991
rename V20009 Transfer1991
rename V19177 RelativeHead1991
rename V19044 HeadHours1991
rename V19074 WifeHours1991
rename V21738 HeadBusi1993
rename V20187 HeadWageHour1991
rename V20188 WifeWageHour1991
rename ER30691 Relation1991
rename ER30734 SequenceNum1992
rename V19350 SexHead1991
rename ER7042 PrincipalRem1996
rename V19003 State1991
rename V20114 RaceHD1st1991
rename V20193 RegionGrowHD1991
rename ER30748 Education1992

rename V20302 IW1992
rename V20651 AgeHead1992
rename V20653 AgeWife1992
rename V22400 ID1993
rename V21484 HeadTotalWage1992
rename V20429 HeadWage1992
rename V20436 WifeTotalWage1992
rename V21309 Transfer1992
rename V20477 RelativeHead1992
rename V20344 HeadHours1992
rename V20374 WifeHours1992
rename ER4119 HeadBusi1994
rename V21493 HeadWageHour1992
rename V21494 WifeWageHour1992
rename ER30735 Relation1992
rename ER30807 SequenceNum1993
rename V20652 SexHead1992
rename ER10044 PrincipalRem1997
rename V20303 State1992
rename V21420 RaceHD1st1992
rename V21499 RegionGrowHD1992
rename ER30820 Education1993

rename V21602 IW1993
rename V22406 AgeHead1993
rename V22408 AgeWife1993
rename ER2005G ID1994
rename V23323 HeadTotalWage1993
rename V21739 HeadWage1993
rename V23324 WifeTotalWage1993
rename V23168 Transfer1993
rename V22156 RelativeHead1993
rename V21634 HeadHours1993
rename V21670 WifeHours1993
rename ER6959 HeadBusi1995
rename ER4148 HeadWageHour1994
rename ER4149 WifeWageHour1994
rename ER30808 Relation1993
rename ER33102 SequenceNum1994
rename V22407 SexHead1993
rename ER13047 PrincipalRem1999
rename V21603 State1993
rename V23276 RaceHD1st1993
rename V23331 RegionGrowHD1993
rename ER33115 Education1994

rename ER2002 IW1994
rename ER2007 AgeHead1994
rename ER2009 AgeWife1994
rename ER5005G ID1995
rename ER4140 HeadTotalWage1994
rename ER4122 HeadWage1994
rename ER3703 Transfer1994
rename ER27976 RelativeHead2005
rename ER4096 HeadHours1994
rename ER4107 WifeHours1994
rename ER9210 HeadBusi1996
rename ER6988 HeadWageHour1995
rename ER6989 WifeWageHour1995
rename ER33103 Relation1994
rename ER33202 SequenceNum1995
rename ER2008 SexHead1994
rename ER17052 PrincipalRem2001
rename ER4156 State1994
rename ER3944 RaceHD1st1994
rename ER4157C RegionGrowHD1994
rename ER33215 Education1995

rename ER5002 IW1995
rename ER5006 AgeHead1995
rename ER5008 AgeWife1995
rename ER7005G ID1996
rename ER6980 HeadTotalWage1995
rename ER6962 HeadWage1995
rename ER6705 Transfer1995
rename ER40966 RelativeHead2007
rename ER6936 HeadHours1995
rename ER6947 WifeHours1995
rename ER12193 HeadBusi1997
rename ER9239 HeadWageHour1996
rename ER9240 WifeWageHour1996
rename ER33203 Relation1995
rename ER33302 SequenceNum1996
rename ER5007 SexHead1995
rename ER21051 PrincipalRem2003
rename ER6996 State1995
rename ER6814 RaceHD1st1995
rename ER6997C RegionGrowHD1995
rename ER33315 Education1996

rename ER7002 IW1996
rename ER7006 AgeHead1996
rename ER7008 AgeWife1996
rename ER10005G ID1997
rename ER9231 HeadTotalWage1996
rename ER9213 HeadWage1996
rename ER8823 Transfer1996
rename ER46874 RelativeHead2009
rename ER9187 HeadHours1996
rename ER9198 WifeHours1996
rename ER16490 HeadBusi1999
rename ER12217 HeadWageHour1997
rename ER12218 WifeWageHour1997
rename ER33303 Relation1996
rename ER33402 SequenceNum1997
rename ER7007 SexHead1996
rename ER25042 PrincipalRem2005
rename ER9247 State1996
rename ER9060 RaceHD1st1996
rename ER9248C RegionGrowHD1996
rename ER33415 Education1997

rename ER10002 IW1997
rename ER10009 AgeHead1997
rename ER10011 AgeWife1997
rename ER13019 ID1999
rename ER12080 HeadTotalWage1997
rename ER12196 HeadWage1997
rename ER11705 Transfer1997
rename ER52282 RelativeHead2011
rename ER12174 HeadHours1997
rename ER12185 WifeHours1997
rename ER20422 HeadBusi2001
rename ER16514 HeadWageHour1999
rename ER16515 WifeWageHour1999
rename ER33403 Relation1997
rename ER33502 SequenceNum1999
rename ER10010 SexHead1997
rename ER36042 PrincipalRem2007
rename ER12221 State1997
rename ER11848 RaceHD1st1997
rename ER12221C RegionGrowHD1997
rename ER33516 Education1999

rename ER13002 IW1999
rename ER13010 AgeHead1999
rename ER13012 AgeWife1999
rename ER17022 ID2001
rename ER16463 HeadTotalWage1999
rename ER16493 HeadWage1999
rename ER14971 Transfer1999
rename ER58085 RelativeHead2013
rename ER16471 HeadHours1999
rename ER16482 WifeHours1999
rename ER24109 HeadBusi2003
rename ER20451 HeadWageHour2001
rename ER20452 WifeWageHour2001
rename ER33503 Relation1999
rename ER33602 SequenceNum2001
rename ER13011 SexHead1999
rename ER42043 PrincipalRem2009
rename ER13004 State1999
rename ER15928 RaceHD1st1999
rename ER16431A RegionGrowHD1999
rename ER33616 Education2001

rename ER17002 IW2001
rename ER17013 AgeHead2001
rename ER17015 AgeWife2001
rename ER21009 ID2003
rename ER20443 HeadTotalWage2001
rename ER20425 HeadWage2001
rename ER19159 Transfer2001
rename ER20399 HeadHours2001
rename ER20410 WifeHours2001
rename ER27910 HeadBusi2005
rename ER24137 HeadWageHour2003
rename ER24138 WifeWageHour2003
rename ER33603 Relation2001
rename ER33702 SequenceNum2003
rename ER17014 SexHead2001
rename ER47348 PrincipalRem2011
rename ER17004 State2001
rename ER19989 RaceHD1st2001
rename ER20377A RegionGrowHD2001
rename ER33716 Education2003

rename ER21002 IW2003
rename ER21017 AgeHead2003
rename ER21019 AgeWife2003
rename ER25009 ID2005
rename ER24116 HeadTotalWage2003
rename ER24117 HeadWage2003
rename ER22532 Transfer2003
rename ER24080 HeadHours2003
rename ER24091 WifeHours2003
rename ER40900 HeadBusi2007
rename ER28003 HeadWageHour2005
rename ER28004 WifeWageHour2005
rename ER33703 Relation2003
rename ER33802 SequenceNum2005
rename ER21018 SexHead2003
rename ER53048 PrincipalRem2013
rename ER21003 State2003
rename ER23426 RaceHD1st2003
rename ER24146 RegionGrowHD2003
rename ER33817 Education2005

rename ER25002 IW2005
rename ER25017 AgeHead2005
rename ER25019 AgeWife2005
rename ER36009 ID2007
rename ER27931 HeadTotalWage2005
rename ER27913 HeadWage2005
rename ER26513 Transfer2005
rename ER27886 HeadHours2005
rename ER27897 WifeHours2005
rename ER46808 HeadBusi2009
rename ER40993 HeadWageHour2007
rename ER40994 WifeWageHour2007
rename ER33803 Relation2005
rename ER33902 SequenceNum2007
rename ER25018 SexHead2005
rename ER25003 State2005
rename ER27393 RaceHD1st2005
rename ER28045 RegionGrowHD2005
rename ER33917 Education2007

rename ER36002 IW2007
rename ER36017 AgeHead2007
rename ER36019 AgeWife2007
rename ER42009 ID2009
rename ER40921 HeadTotalWage2007
rename ER40903 HeadWage2007
rename ER37531 Transfer2007
rename ER40876 HeadHours2007
rename ER40887 WifeHours2007
rename ER52216 HeadBusi2011
rename ER46901 HeadWageHour2009
rename ER46902 WifeWageHour2009
rename ER33903 Relation2007
rename ER34002 SequenceNum2009
rename ER36018 SexHead2007
rename ER36003 State2007
rename ER40565 RaceHD1st2007
rename ER41035 RegionGrowHD2007
rename ER34020 Education2009

rename ER42002 IW2009
rename ER42017 AgeHead2009
rename ER42019 AgeWife2009
rename ER47309 ID2011
rename ER46829 HeadTotalWage2009
rename ER46811 HeadWage2009
rename ER43522 Transfer2009
rename ER46767 HeadHours2009
rename ER46788 WifeHours2009
rename ER58017 HeadBusi2013
rename ER52309 HeadWageHour2011
rename ER52310 WifeWageHour2011
rename ER34003 Relation2009
rename ER34102 SequenceNum2011
rename ER42018 SexHead2009
rename ER42003 State2009
rename ER46543 RaceHD1st2009
rename ER46977 RegionGrowHD2009
rename ER34119 Education2011

rename ER47302 IW2011
rename ER47317 AgeHead2011
rename ER47319 AgeWife2011
rename ER53009 ID2013
rename ER52237 HeadTotalWage2011
rename ER52219 HeadWage2011
rename ER48847 Transfer2011
rename ER52175 HeadHours2011
rename ER52196 WifeHours2011
rename ER58118 HeadWageHour2013
rename ER58119 WifeWageHour2013
rename ER34103 Relation2011
rename ER34202 SequenceNum2013
rename ER47318 SexHead2011
rename ER47303 State2011
rename ER51904 RaceHD1st2011
rename ER52401 RegionGrowHD2011
rename ER34230 Education2013

rename ER53002 IW2013
rename ER53017 AgeHead2013
rename ER53019 AgeWife2013
rename ER58038 HeadTotalWage2013
rename ER58020 HeadWage2013
rename ER54590 Transfer2013
rename ER57976 HeadHours2013
rename ER57997 WifeHours2013
rename ER34203 Relation2013
rename ER53018 SexHead2013
rename ER53003 State2013
rename ER57659 RaceHD1st2013
rename ER58219 RegionGrowHD2013

drop ER*
drop V*
gen ID1968= IW1968
* get the unique identifier by ID1968*1000+ personal number
reshape long IW AgeHead AgeWife ID HeadTotalWage HeadWage WifeTotalWage WifeTotalWageExcludeBusi WifeBusiness Transfer SrcOfTransfer Inheritance NonrelativeHead NonrelativeHeadReport NonrelativeHeadReportUnit NonrelativeWife NonrelativeWifeReport NonrelativeWifeReportUnit RelativeHead RelativeHeadReport RelativeHeadReportUnit RelativeWife RelativeWifeReport RelativeWifeReportUnit HeadHours WifeHours HeadBusi HeadWageHour WifeWageHour Relation SequenceNum SexHead PrincipalRem WealthExclH WealthInclH State RaceHD1st RaceHD2nd RaceHD3rd RaceHD4th RegionGrowHD Education , i(identifier) j(year)
sort ID year SequenceNum Relation
order ID year SequenceNum Relation
save Data_reshaped.dta, replace
